<template>
  <div class="block-chat-btn">
    <template v-if="showButton">
      <button
        v-if="auth === null"
        class="ui button transparent"
        @click="beginChat"
        v-tooltip="tooltip">
        <span class="btn-chat-cloud"/>
      </button>
      <button
        v-else-if="isChatOpened"
        :disabled="loading"
        :class="{ loading }"
        class="ui button transparent"
        @click="createDialog"
        v-tooltip="tooltip">
        <span class="btn-chat-cloud"/>
      </button>
    </template>

    <v-popover
      v-if="showOnline && isOnline"
      popover-base-class="ui popup tooltip visible dark bottom"
      trigger="hover"
      placement="bottom"
      offset="4"
      delay="0">
      <span class="marker-online">online</span>
      <template slot="popover">Продавец сейчас на сайте</template>
    </v-popover>
  </div>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';

import { SHOW_AUTH_MODAL, SHOW_BEGIN_CHAT_MODAL } from '~/assets/js/store/actionManager/mutation-types';
import { SHOW_ROOM, GET_SHOP_ONLINE_STATUS } from '~/assets/js/store/chat/action-types';
import { SET_OPEN_DIALOG_ONLOAD } from '~/assets/js/store/chat/mutation-types';

import getDialogRequest from '~/assets/js/helpers/chat-get-dialog-request';

const STORE_CHAT = createNamespacedHelpers('chat');
const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
const STORE_USER = createNamespacedHelpers('user');

export default {
  name: 'ChatWidget',
  props: {
    type: {
      type: String,
      required: true,
      default: '',
    },
    id: {
      type: Number,
      required: true,
      default: 0,
    },
    params: {
      type: Object,
      default() { return {}; },
    },
    showOnline: {
      type: Boolean,
      default: true,
    },
    showButton: {
      type: Boolean,
      default: true,
    },
  },
  data() {
    return {
      tooltip: {
        content: 'Начать чат с продавцом',
        classes: 'ui popup tooltip visible dark bottom chat-start',
        placement: 'bottom',
        trigger: 'hover',
        offset: 4,
        delay: 0,
      },
      loading: false,
      online: {
        status: false,
        loaded: false,
      },
    };
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
    ...STORE_CHAT.mapState({
      isChatOpened: 'opened',
    }),
    isOnline() {
      return this.online.status && this.online.loaded;
    },
  },
  mounted() {
    if (this.showOnline) {
      this.loadOnlineStatus();
    }
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      showAuthModal: SHOW_AUTH_MODAL,
      showBeginChatModal: SHOW_BEGIN_CHAT_MODAL,
    }),
    ...STORE_CHAT.mapMutations({
      setOpenRoomOnload: SET_OPEN_DIALOG_ONLOAD,
    }),
    ...STORE_CHAT.mapActions({
      showRoom: SHOW_ROOM,
      getShopOnlineStatus: GET_SHOP_ONLINE_STATUS,
    }),
    beginChat() {
      this.$ym('chat_click_nonauth');
      this.setOpenRoomOnload({
        type: this.type,
        id: this.id,
        params: this.params,
      });
      this.showBeginChatModal();
    },
    loadOnlineStatus() {
      let shopId = null;
      switch (this.type) {
        case 'request':
          break;
        case 'order':
          break;
        case 'shop':
          shopId = this.id;
          break;
        case 'contractPart':
          // вероятно к моменту, когда нужно обрабатывать 'request' & 'order'
          // shopId стоит сделать отдельным Prop
          ({ shopId } = this.params);
          break;
        default:
      }
      if (shopId !== null) {
        this.getShopOnlineStatus({ id: shopId })
          .then((status) => {
            this.online.status = status;
          })
          .finally(() => {
            this.online.loaded = true;
          });
      }
    },
    createDialog() {
      this.$ym('chat_click_auth');
      const promise = getDialogRequest.call(this, this.type, this.id, this.params);
      if (promise !== null) {
        this.loading = true;
        promise
          .then(({ data }) => {
            this.showRoom({ window, roomId: data.roomId, type: data.type });
          }).finally(() => {
            this.loading = false;
          });
      }
    },
  },
};
</script>

<style scoped lang="scss">
  .btn-chat-cloud {
    margin-top: -0.3125rem;
  }

  .ui.button.transparent {
    display: flex;
    padding: 0;
    margin: 0;
    box-shadow: none;
    .btn-chat-cloud {
      margin: auto;
    }

    &.loading {
      .btn-chat-cloud {
        opacity: 0;
      }
    }
  }
  .block-chat-btn {
    display: inline-flex;
    flex-direction: row;
    flex-wrap: nowrap;
    justify-content: flex-start;
    align-items: center;
    line-height: 1;
    white-space: nowrap;
  }
  .block-chat-btn .v-popover {
    display: inline-flex;
    min-height: 1.125rem;
    line-height: 1.125rem;
  }

  .marker-online {
    display: inline-block;
    padding-left: 0.75rem;
    font-size: 0.6875rem;
    line-height: 1;
    color: #009933;
    background-position: left center;
    background-size: 0.5rem auto;
    background-repeat: no-repeat;
    background-image: url("~assets/svg/icons/man.svg");
    cursor: pointer;
  }
</style>
